=begin
--------------------------------------------------------------------------------------------------------------------
 <copyright company="Aspose" file="ApiErrorrb.cs">
   Copyright (c) 2024 Aspose.Cells Cloud
 </copyright>
 <summary>
   Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the "Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in all
  copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.
 </summary>
--------------------------------------------------------------------------------------------------------------------
=end


require 'aspose_cells_cloud/api_client'
require 'aspose_cells_cloud/api_error'
require 'aspose_cells_cloud/version'
require 'aspose_cells_cloud/configuration'

# Models
require 'aspose_cells_cloud/models/disc_usage'
require 'aspose_cells_cloud/models/object_exist'
require 'aspose_cells_cloud/models/object_exists_extensions'
require 'aspose_cells_cloud/models/file_version'
require 'aspose_cells_cloud/models/storage_exist'
require 'aspose_cells_cloud/models/file_versions'
require 'aspose_cells_cloud/models/files_list'
require 'aspose_cells_cloud/models/files_upload_result'
require 'aspose_cells_cloud/models/storage_file'
require 'aspose_cells_cloud/models/google_drive_storage_file'
require 'aspose_cells_cloud/models/above_average'
require 'aspose_cells_cloud/models/abstract_calculation_engine'
require 'aspose_cells_cloud/models/abstract_calculation_monitor'
require 'aspose_cells_cloud/models/auto_filter'
require 'aspose_cells_cloud/models/auto_fitter_options'
require 'aspose_cells_cloud/models/border'
require 'aspose_cells_cloud/models/calculation_options'
require 'aspose_cells_cloud/models/cell'
require 'aspose_cells_cloud/models/cell_area'
require 'aspose_cells_cloud/models/cells'
require 'aspose_cells_cloud/models/cells_cloud_file_info'
require 'aspose_cells_cloud/models/cells_color'
require 'aspose_cells_cloud/models/cells_document_properties'
require 'aspose_cells_cloud/models/cells_document_property'
require 'aspose_cells_cloud/models/color'
require 'aspose_cells_cloud/models/color_filter'
require 'aspose_cells_cloud/models/color_scale'
require 'aspose_cells_cloud/models/column'
require 'aspose_cells_cloud/models/columns'
require 'aspose_cells_cloud/models/comment'
require 'aspose_cells_cloud/models/comments'
require 'aspose_cells_cloud/models/conditional_formatting'
require 'aspose_cells_cloud/models/conditional_formatting_icon'
require 'aspose_cells_cloud/models/conditional_formattings'
require 'aspose_cells_cloud/models/conditional_formatting_value'
require 'aspose_cells_cloud/models/copy_options'
require 'aspose_cells_cloud/models/criteria_multiple_filter'
require 'aspose_cells_cloud/models/custom_filter'
require 'aspose_cells_cloud/models/data_bar'
require 'aspose_cells_cloud/models/data_bar_border'
require 'aspose_cells_cloud/models/data_cleansing'
require 'aspose_cells_cloud/models/data_column_fill_value'
require 'aspose_cells_cloud/models/data_fill'
require 'aspose_cells_cloud/models/data_fill_value'
require 'aspose_cells_cloud/models/data_item'
require 'aspose_cells_cloud/models/data_sorter'
require 'aspose_cells_cloud/models/data_sorter_key'
require 'aspose_cells_cloud/models/data_source'
require 'aspose_cells_cloud/models/date_time_group_item'
require 'aspose_cells_cloud/models/deduplication_region'
require 'aspose_cells_cloud/models/dynamic_filter'
require 'aspose_cells_cloud/models/file_info'
require 'aspose_cells_cloud/models/file_source'
require 'aspose_cells_cloud/models/files_result'
require 'aspose_cells_cloud/models/filter_column'
require 'aspose_cells_cloud/models/font'
require 'aspose_cells_cloud/models/font_setting'
require 'aspose_cells_cloud/models/format_condition'
require 'aspose_cells_cloud/models/formula_format_condition'
require 'aspose_cells_cloud/models/formula_settings'
require 'aspose_cells_cloud/models/globalization_settings'
require 'aspose_cells_cloud/models/horizontal_page_break'
require 'aspose_cells_cloud/models/horizontal_page_breaks'
require 'aspose_cells_cloud/models/hyperlink'
require 'aspose_cells_cloud/models/hyperlinks'
require 'aspose_cells_cloud/models/icon_filter'
require 'aspose_cells_cloud/models/icon_set'
require 'aspose_cells_cloud/models/link'
require 'aspose_cells_cloud/models/link_element'
require 'aspose_cells_cloud/models/load_options'
require 'aspose_cells_cloud/models/merged_cell'
require 'aspose_cells_cloud/models/merged_cells'
require 'aspose_cells_cloud/models/multiple_filter'
require 'aspose_cells_cloud/models/multiple_filters'
require 'aspose_cells_cloud/models/name'
require 'aspose_cells_cloud/models/names'
require 'aspose_cells_cloud/models/negative_bar_format'
require 'aspose_cells_cloud/models/page_section'
require 'aspose_cells_cloud/models/page_setup'
require 'aspose_cells_cloud/models/paste_options'
require 'aspose_cells_cloud/models/pdf_security_options'
require 'aspose_cells_cloud/models/protection'
require 'aspose_cells_cloud/models/protect_sheet_parameter'
require 'aspose_cells_cloud/models/range'
require 'aspose_cells_cloud/models/ranges'
require 'aspose_cells_cloud/models/row'
require 'aspose_cells_cloud/models/rows'
require 'aspose_cells_cloud/models/save_result'
require 'aspose_cells_cloud/models/paginated_save_options'
require 'aspose_cells_cloud/models/single_value'
require 'aspose_cells_cloud/models/sort_key'
require 'aspose_cells_cloud/models/split_result'
require 'aspose_cells_cloud/models/style'
require 'aspose_cells_cloud/models/style_format_condition'
require 'aspose_cells_cloud/models/styles'
require 'aspose_cells_cloud/models/text_format_condition'
require 'aspose_cells_cloud/models/text_item'
require 'aspose_cells_cloud/models/text_items'
require 'aspose_cells_cloud/models/text_options'
require 'aspose_cells_cloud/models/theme_color'
require 'aspose_cells_cloud/models/time_period_format_condition'
require 'aspose_cells_cloud/models/top10'
require 'aspose_cells_cloud/models/top10_filter'
require 'aspose_cells_cloud/models/validation'
require 'aspose_cells_cloud/models/validations'
require 'aspose_cells_cloud/models/vertical_page_break'
require 'aspose_cells_cloud/models/vertical_page_breaks'
require 'aspose_cells_cloud/models/workbook'
require 'aspose_cells_cloud/models/workbook_settings'
require 'aspose_cells_cloud/models/worksheet'
require 'aspose_cells_cloud/models/worksheets'
require 'aspose_cells_cloud/models/write_protection'
require 'aspose_cells_cloud/models/xml_data_binding'
require 'aspose_cells_cloud/models/xml_map'
require 'aspose_cells_cloud/models/cells_object_operate_task_parameter'
require 'aspose_cells_cloud/models/convert_task_parameter'
require 'aspose_cells_cloud/models/convert_worksheet_task_parameter'
require 'aspose_cells_cloud/models/import_data_task_parameter'
require 'aspose_cells_cloud/models/result_destination'
require 'aspose_cells_cloud/models/save_files_to_cloud_result'
require 'aspose_cells_cloud/models/save_result_task_parameter'
require 'aspose_cells_cloud/models/smart_marker_task_parameter'
require 'aspose_cells_cloud/models/split_workbook_task_parameter'
require 'aspose_cells_cloud/models/task_data'
require 'aspose_cells_cloud/models/task_description'
require 'aspose_cells_cloud/models/task_parameter'
require 'aspose_cells_cloud/models/task_result_parameter'
require 'aspose_cells_cloud/models/task_run_result'
require 'aspose_cells_cloud/models/chart_operate_parameter'
require 'aspose_cells_cloud/models/list_object_operate_parameter'
require 'aspose_cells_cloud/models/operate_object'
require 'aspose_cells_cloud/models/operate_object_position'
require 'aspose_cells_cloud/models/operate_parameter'
require 'aspose_cells_cloud/models/page_break_operate_parameter'
require 'aspose_cells_cloud/models/page_setup_operate_parameter'
require 'aspose_cells_cloud/models/pivot_table_operate_parameter'
require 'aspose_cells_cloud/models/shape_operate_parameter'
require 'aspose_cells_cloud/models/workbook_operate_parameter'
require 'aspose_cells_cloud/models/workbook_settings_operate_parameter'
require 'aspose_cells_cloud/models/worksheet_operate_parameter'
require 'aspose_cells_cloud/models/list_column'
require 'aspose_cells_cloud/models/list_object'
require 'aspose_cells_cloud/models/list_objects'
require 'aspose_cells_cloud/models/pivot_globalization_settings'
require 'aspose_cells_cloud/models/dif_save_options'
require 'aspose_cells_cloud/models/docx_save_options'
require 'aspose_cells_cloud/models/html_save_options'
require 'aspose_cells_cloud/models/image_save_options'
require 'aspose_cells_cloud/models/json_save_options'
require 'aspose_cells_cloud/models/markdown_save_options'
require 'aspose_cells_cloud/models/m_html_save_options'
require 'aspose_cells_cloud/models/ods_save_options'
require 'aspose_cells_cloud/models/ooxml_save_options'
require 'aspose_cells_cloud/models/pdf_save_options'
require 'aspose_cells_cloud/models/pptx_save_options'
require 'aspose_cells_cloud/models/save_options'
require 'aspose_cells_cloud/models/spreadsheet_m_l2003_save_options'
require 'aspose_cells_cloud/models/sql_script_save_options'
require 'aspose_cells_cloud/models/svg_save_options'
require 'aspose_cells_cloud/models/txt_save_options'
require 'aspose_cells_cloud/models/xlsb_save_options'
require 'aspose_cells_cloud/models/xls_save_options'
require 'aspose_cells_cloud/models/xps_save_options'
require 'aspose_cells_cloud/models/arc_shape_response'
require 'aspose_cells_cloud/models/auto_filter_response'
require 'aspose_cells_cloud/models/auto_shape_response'
require 'aspose_cells_cloud/models/auto_shapes_response'
require 'aspose_cells_cloud/models/axis_response'
require 'aspose_cells_cloud/models/border_response'
require 'aspose_cells_cloud/models/button_response'
require 'aspose_cells_cloud/models/calculate_formula_response'
require 'aspose_cells_cloud/models/cell_response'
require 'aspose_cells_cloud/models/cells_cloud_file_info_response'
require 'aspose_cells_cloud/models/cells_cloud_response'
require 'aspose_cells_cloud/models/cells_document_properties_response'
require 'aspose_cells_cloud/models/cells_document_property_response'
require 'aspose_cells_cloud/models/cells_drawing_response'
require 'aspose_cells_cloud/models/cells_response'
require 'aspose_cells_cloud/models/chart_area_response'
require 'aspose_cells_cloud/models/chart_data_table_response'
require 'aspose_cells_cloud/models/chart_point_response'
require 'aspose_cells_cloud/models/chart_points_response'
require 'aspose_cells_cloud/models/chart_response'
require 'aspose_cells_cloud/models/charts_response'
require 'aspose_cells_cloud/models/check_box_response'
require 'aspose_cells_cloud/models/column_response'
require 'aspose_cells_cloud/models/columns_response'
require 'aspose_cells_cloud/models/combo_box_response'
require 'aspose_cells_cloud/models/comment_response'
require 'aspose_cells_cloud/models/comment_shape_response'
require 'aspose_cells_cloud/models/comments_response'
require 'aspose_cells_cloud/models/conditional_formatting_response'
require 'aspose_cells_cloud/models/conditional_formattings_response'
require 'aspose_cells_cloud/models/data_labels_response'
require 'aspose_cells_cloud/models/display_unit_label_response'
require 'aspose_cells_cloud/models/drop_bars_response'
require 'aspose_cells_cloud/models/error_bar_response'
require 'aspose_cells_cloud/models/fill_format_response'
require 'aspose_cells_cloud/models/find_response'
require 'aspose_cells_cloud/models/floor_response'
require 'aspose_cells_cloud/models/form_response'
require 'aspose_cells_cloud/models/forms_response'
require 'aspose_cells_cloud/models/group_box_response'
require 'aspose_cells_cloud/models/horizontal_page_break_response'
require 'aspose_cells_cloud/models/horizontal_page_breaks_response'
require 'aspose_cells_cloud/models/hyperlink_response'
require 'aspose_cells_cloud/models/hyperlinks_response'
require 'aspose_cells_cloud/models/label_response'
require 'aspose_cells_cloud/models/legend_entries_response'
require 'aspose_cells_cloud/models/legend_entry_response'
require 'aspose_cells_cloud/models/legend_response'
require 'aspose_cells_cloud/models/line_response'
require 'aspose_cells_cloud/models/line_shape_response'
require 'aspose_cells_cloud/models/list_box_response'
require 'aspose_cells_cloud/models/list_object_response'
require 'aspose_cells_cloud/models/list_objects_response'
require 'aspose_cells_cloud/models/merged_cell_response'
require 'aspose_cells_cloud/models/merged_cells_response'
require 'aspose_cells_cloud/models/name_response'
require 'aspose_cells_cloud/models/names_response'
require 'aspose_cells_cloud/models/ole_object_response'
require 'aspose_cells_cloud/models/ole_objects_response'
require 'aspose_cells_cloud/models/oval_response'
require 'aspose_cells_cloud/models/page_sections_response'
require 'aspose_cells_cloud/models/page_setup_response'
require 'aspose_cells_cloud/models/picture_response'
require 'aspose_cells_cloud/models/pictures_response'
require 'aspose_cells_cloud/models/pivot_field_response'
require 'aspose_cells_cloud/models/pivot_filter_response'
require 'aspose_cells_cloud/models/pivot_filters_response'
require 'aspose_cells_cloud/models/pivot_table_response'
require 'aspose_cells_cloud/models/pivot_tables_response'
require 'aspose_cells_cloud/models/plot_area_response'
require 'aspose_cells_cloud/models/radio_button_response'
require 'aspose_cells_cloud/models/range_response'
require 'aspose_cells_cloud/models/ranges_response'
require 'aspose_cells_cloud/models/range_value_response'
require 'aspose_cells_cloud/models/rectangle_shape_response'
require 'aspose_cells_cloud/models/row_response'
require 'aspose_cells_cloud/models/rows_response'
require 'aspose_cells_cloud/models/save_files_to_cloud_result_response'
require 'aspose_cells_cloud/models/save_response'
require 'aspose_cells_cloud/models/scroll_bar_response'
require 'aspose_cells_cloud/models/serieses_response'
require 'aspose_cells_cloud/models/series_response'
require 'aspose_cells_cloud/models/shape_response'
require 'aspose_cells_cloud/models/shapes_response'
require 'aspose_cells_cloud/models/single_value_response'
require 'aspose_cells_cloud/models/sparkline_group_response'
require 'aspose_cells_cloud/models/sparkline_groups_response'
require 'aspose_cells_cloud/models/spinner_response'
require 'aspose_cells_cloud/models/split_result_response'
require 'aspose_cells_cloud/models/style_response'
require 'aspose_cells_cloud/models/task_run_result_response'
require 'aspose_cells_cloud/models/text_box_response'
require 'aspose_cells_cloud/models/text_item_response'
require 'aspose_cells_cloud/models/text_items_response'
require 'aspose_cells_cloud/models/tick_labels_response'
require 'aspose_cells_cloud/models/title_response'
require 'aspose_cells_cloud/models/trendline_response'
require 'aspose_cells_cloud/models/trendlines_response'
require 'aspose_cells_cloud/models/validation_response'
require 'aspose_cells_cloud/models/validations_response'
require 'aspose_cells_cloud/models/vertical_page_break_response'
require 'aspose_cells_cloud/models/vertical_page_breaks_response'
require 'aspose_cells_cloud/models/walls_response'
require 'aspose_cells_cloud/models/workbook_replace_response'
require 'aspose_cells_cloud/models/workbook_response'
require 'aspose_cells_cloud/models/workbook_settings_response'
require 'aspose_cells_cloud/models/workbooks_response'
require 'aspose_cells_cloud/models/worksheet_replace_response'
require 'aspose_cells_cloud/models/worksheet_response'
require 'aspose_cells_cloud/models/worksheets_response'
require 'aspose_cells_cloud/models/analyze_excel_request'
require 'aspose_cells_cloud/models/batch_convert_request'
require 'aspose_cells_cloud/models/batch_lock_request'
require 'aspose_cells_cloud/models/batch_protect_request'
require 'aspose_cells_cloud/models/batch_split_request'
require 'aspose_cells_cloud/models/color_filter_request'
require 'aspose_cells_cloud/models/convert_parameter'
require 'aspose_cells_cloud/models/create_pivot_table_request'
require 'aspose_cells_cloud/models/data_cleansing_request'
require 'aspose_cells_cloud/models/data_deduplication_request'
require 'aspose_cells_cloud/models/data_fill_request'
require 'aspose_cells_cloud/models/data_transformation_request'
require 'aspose_cells_cloud/models/delete_incomplete_rows_request'
require 'aspose_cells_cloud/models/import_json_request'
require 'aspose_cells_cloud/models/import_xml_request'
require 'aspose_cells_cloud/models/match_condition_request'
require 'aspose_cells_cloud/models/password_request'
require 'aspose_cells_cloud/models/pivot_table_field_request'
require 'aspose_cells_cloud/models/protect_workbook_request'
require 'aspose_cells_cloud/models/range_copy_request'
require 'aspose_cells_cloud/models/range_set_outline_border_request'
require 'aspose_cells_cloud/models/range_set_style_request'
require 'aspose_cells_cloud/models/range_sort_request'
require 'aspose_cells_cloud/models/table_total_request'
require 'aspose_cells_cloud/models/text_water_marker_request'
require 'aspose_cells_cloud/models/workbook_encryption_request'
require 'aspose_cells_cloud/models/workbook_protection_request'
require 'aspose_cells_cloud/models/worksheet_moving_request'
require 'aspose_cells_cloud/models/image_or_print_options'
require 'aspose_cells_cloud/models/rendering_font'
require 'aspose_cells_cloud/models/rendering_watermark'
require 'aspose_cells_cloud/models/applied_operate'
require 'aspose_cells_cloud/models/applied_step'
require 'aspose_cells_cloud/models/data_query'
require 'aspose_cells_cloud/models/load_data'
require 'aspose_cells_cloud/models/load_to'
require 'aspose_cells_cloud/models/merge_queries'
require 'aspose_cells_cloud/models/pivot_column'
require 'aspose_cells_cloud/models/unpivot_column'
require 'aspose_cells_cloud/models/pivot_field'
require 'aspose_cells_cloud/models/pivot_filter'
require 'aspose_cells_cloud/models/pivot_item'
require 'aspose_cells_cloud/models/pivot_table'
require 'aspose_cells_cloud/models/pivot_tables'
require 'aspose_cells_cloud/models/add_text_options'
require 'aspose_cells_cloud/models/base_operate_options'
require 'aspose_cells_cloud/models/remove_characters_by_character'
require 'aspose_cells_cloud/models/remove_characters_by_position'
require 'aspose_cells_cloud/models/remove_characters_options'
require 'aspose_cells_cloud/models/scope_item'
require 'aspose_cells_cloud/models/scope_options'
require 'aspose_cells_cloud/models/trim_content_options'
require 'aspose_cells_cloud/models/word_case_options'
require 'aspose_cells_cloud/models/cell_value'
require 'aspose_cells_cloud/models/custom_parser_config'
require 'aspose_cells_cloud/models/import2_dimension_double_array_option'
require 'aspose_cells_cloud/models/import2_dimension_int_array_option'
require 'aspose_cells_cloud/models/import2_dimension_string_array_option'
require 'aspose_cells_cloud/models/import_batch_data_option'
require 'aspose_cells_cloud/models/import_csv_data_option'
require 'aspose_cells_cloud/models/import_double_array_option'
require 'aspose_cells_cloud/models/import_int_array_option'
require 'aspose_cells_cloud/models/import_option'
require 'aspose_cells_cloud/models/import_picture_option'
require 'aspose_cells_cloud/models/import_position'
require 'aspose_cells_cloud/models/import_string_array_option'
require 'aspose_cells_cloud/models/arc_shape'
require 'aspose_cells_cloud/models/area'
require 'aspose_cells_cloud/models/auto_shape'
require 'aspose_cells_cloud/models/auto_shapes'
require 'aspose_cells_cloud/models/button'
require 'aspose_cells_cloud/models/cells_drawing'
require 'aspose_cells_cloud/models/check_box'
require 'aspose_cells_cloud/models/combo_box'
require 'aspose_cells_cloud/models/comment_shape'
require 'aspose_cells_cloud/models/fill_format'
require 'aspose_cells_cloud/models/form'
require 'aspose_cells_cloud/models/forms'
require 'aspose_cells_cloud/models/gradient_fill'
require 'aspose_cells_cloud/models/gradient_fill_stop'
require 'aspose_cells_cloud/models/group_box'
require 'aspose_cells_cloud/models/group_shape'
require 'aspose_cells_cloud/models/label'
require 'aspose_cells_cloud/models/line'
require 'aspose_cells_cloud/models/line_format'
require 'aspose_cells_cloud/models/line_shape'
require 'aspose_cells_cloud/models/list_box'
require 'aspose_cells_cloud/models/ole_object'
require 'aspose_cells_cloud/models/ole_objects'
require 'aspose_cells_cloud/models/oval'
require 'aspose_cells_cloud/models/pattern_fill'
require 'aspose_cells_cloud/models/pic_format_option'
require 'aspose_cells_cloud/models/picture'
require 'aspose_cells_cloud/models/pictures'
require 'aspose_cells_cloud/models/radio_button'
require 'aspose_cells_cloud/models/rectangle_shape'
require 'aspose_cells_cloud/models/scroll_bar'
require 'aspose_cells_cloud/models/shadow_effect'
require 'aspose_cells_cloud/models/shape'
require 'aspose_cells_cloud/models/shapes'
require 'aspose_cells_cloud/models/solid_fill'
require 'aspose_cells_cloud/models/spinner'
require 'aspose_cells_cloud/models/text_box'
require 'aspose_cells_cloud/models/texture_fill'
require 'aspose_cells_cloud/models/tile_pic_option'
require 'aspose_cells_cloud/models/digital_signature'
require 'aspose_cells_cloud/models/axis'
require 'aspose_cells_cloud/models/chart'
require 'aspose_cells_cloud/models/chart_area'
require 'aspose_cells_cloud/models/chart_data_table'
require 'aspose_cells_cloud/models/chart_frame'
require 'aspose_cells_cloud/models/chart_globalization_settings'
require 'aspose_cells_cloud/models/chart_point'
require 'aspose_cells_cloud/models/chart_points'
require 'aspose_cells_cloud/models/charts'
require 'aspose_cells_cloud/models/chart_shape'
require 'aspose_cells_cloud/models/data_labels'
require 'aspose_cells_cloud/models/display_unit_label'
require 'aspose_cells_cloud/models/drop_bars'
require 'aspose_cells_cloud/models/error_bar'
require 'aspose_cells_cloud/models/floor'
require 'aspose_cells_cloud/models/legend'
require 'aspose_cells_cloud/models/legend_entries'
require 'aspose_cells_cloud/models/legend_entry'
require 'aspose_cells_cloud/models/marker'
require 'aspose_cells_cloud/models/plot_area'
require 'aspose_cells_cloud/models/series'
require 'aspose_cells_cloud/models/series_items'
require 'aspose_cells_cloud/models/sparkline'
require 'aspose_cells_cloud/models/sparkline_group'
require 'aspose_cells_cloud/models/sparkline_groups'
require 'aspose_cells_cloud/models/tick_labels'
require 'aspose_cells_cloud/models/title'
require 'aspose_cells_cloud/models/trendline'
require 'aspose_cells_cloud/models/trendlines'
require 'aspose_cells_cloud/models/walls'
require 'aspose_cells_cloud/models/analyzed_column_description'
require 'aspose_cells_cloud/models/analyzed_result'
require 'aspose_cells_cloud/models/analyzed_table_description'
require 'aspose_cells_cloud/models/discover_chart'
require 'aspose_cells_cloud/models/discover_pivot_table'
require 'aspose_cells_cloud/models/excel_data_statistics'
require 'aspose_cells_cloud/models/worksheet_data_statistics'
require 'aspose_cells_cloud/models/error'
require 'aspose_cells_cloud/models/error_details'

# Requests
require 'aspose_cells_cloud/requests/post_analyze_excel_request'
require 'aspose_cells_cloud/requests/get_worksheet_auto_filter_request'
require 'aspose_cells_cloud/requests/put_worksheet_date_filter_request'
require 'aspose_cells_cloud/requests/put_worksheet_filter_request'
require 'aspose_cells_cloud/requests/put_worksheet_icon_filter_request'
require 'aspose_cells_cloud/requests/put_worksheet_custom_filter_request'
require 'aspose_cells_cloud/requests/put_worksheet_dynamic_filter_request'
require 'aspose_cells_cloud/requests/put_worksheet_filter_top10_request'
require 'aspose_cells_cloud/requests/put_worksheet_color_filter_request'
require 'aspose_cells_cloud/requests/post_worksheet_match_blanks_request'
require 'aspose_cells_cloud/requests/post_worksheet_match_non_blanks_request'
require 'aspose_cells_cloud/requests/post_worksheet_auto_filter_refresh_request'
require 'aspose_cells_cloud/requests/delete_worksheet_date_filter_request'
require 'aspose_cells_cloud/requests/delete_worksheet_filter_request'
require 'aspose_cells_cloud/requests/get_worksheet_autoshapes_request'
require 'aspose_cells_cloud/requests/get_worksheet_autoshape_with_format_request'
require 'aspose_cells_cloud/requests/post_batch_convert_request'
require 'aspose_cells_cloud/requests/post_batch_protect_request'
require 'aspose_cells_cloud/requests/post_batch_lock_request'
require 'aspose_cells_cloud/requests/post_batch_unlock_request'
require 'aspose_cells_cloud/requests/post_batch_split_request'
require 'aspose_cells_cloud/requests/post_access_token_request'
require 'aspose_cells_cloud/requests/post_clear_contents_request'
require 'aspose_cells_cloud/requests/post_clear_formats_request'
require 'aspose_cells_cloud/requests/post_update_worksheet_range_style_request'
require 'aspose_cells_cloud/requests/post_worksheet_merge_request'
require 'aspose_cells_cloud/requests/post_worksheet_unmerge_request'
require 'aspose_cells_cloud/requests/get_worksheet_cells_request'
require 'aspose_cells_cloud/requests/get_worksheet_cell_request'
require 'aspose_cells_cloud/requests/get_worksheet_cell_style_request'
require 'aspose_cells_cloud/requests/post_worksheet_cell_set_value_request'
require 'aspose_cells_cloud/requests/post_update_worksheet_cell_style_request'
require 'aspose_cells_cloud/requests/post_set_cell_range_value_request'
require 'aspose_cells_cloud/requests/post_copy_cell_into_cell_request'
require 'aspose_cells_cloud/requests/get_cell_html_string_request'
require 'aspose_cells_cloud/requests/post_set_cell_html_string_request'
require 'aspose_cells_cloud/requests/post_cell_calculate_request'
require 'aspose_cells_cloud/requests/post_cell_characters_request'
require 'aspose_cells_cloud/requests/get_worksheet_columns_request'
require 'aspose_cells_cloud/requests/post_set_worksheet_column_width_request'
require 'aspose_cells_cloud/requests/get_worksheet_column_request'
require 'aspose_cells_cloud/requests/put_insert_worksheet_columns_request'
require 'aspose_cells_cloud/requests/delete_worksheet_columns_request'
require 'aspose_cells_cloud/requests/post_hide_worksheet_columns_request'
require 'aspose_cells_cloud/requests/post_unhide_worksheet_columns_request'
require 'aspose_cells_cloud/requests/post_group_worksheet_columns_request'
require 'aspose_cells_cloud/requests/post_ungroup_worksheet_columns_request'
require 'aspose_cells_cloud/requests/post_copy_worksheet_columns_request'
require 'aspose_cells_cloud/requests/post_column_style_request'
require 'aspose_cells_cloud/requests/get_worksheet_rows_request'
require 'aspose_cells_cloud/requests/get_worksheet_row_request'
require 'aspose_cells_cloud/requests/delete_worksheet_row_request'
require 'aspose_cells_cloud/requests/delete_worksheet_rows_request'
require 'aspose_cells_cloud/requests/put_insert_worksheet_rows_request'
require 'aspose_cells_cloud/requests/put_insert_worksheet_row_request'
require 'aspose_cells_cloud/requests/post_update_worksheet_row_request'
require 'aspose_cells_cloud/requests/post_hide_worksheet_rows_request'
require 'aspose_cells_cloud/requests/post_unhide_worksheet_rows_request'
require 'aspose_cells_cloud/requests/post_group_worksheet_rows_request'
require 'aspose_cells_cloud/requests/post_ungroup_worksheet_rows_request'
require 'aspose_cells_cloud/requests/post_copy_worksheet_rows_request'
require 'aspose_cells_cloud/requests/post_row_style_request'
require 'aspose_cells_cloud/requests/get_cells_cloud_services_health_check_request'
require 'aspose_cells_cloud/requests/get_cells_cloud_service_status_request'
require 'aspose_cells_cloud/requests/get_chart_area_request'
require 'aspose_cells_cloud/requests/get_chart_area_fill_format_request'
require 'aspose_cells_cloud/requests/get_chart_area_border_request'
require 'aspose_cells_cloud/requests/get_worksheet_charts_request'
require 'aspose_cells_cloud/requests/get_worksheet_chart_request'
require 'aspose_cells_cloud/requests/put_worksheet_chart_request'
require 'aspose_cells_cloud/requests/delete_worksheet_chart_request'
require 'aspose_cells_cloud/requests/post_worksheet_chart_request'
require 'aspose_cells_cloud/requests/get_worksheet_chart_legend_request'
require 'aspose_cells_cloud/requests/post_worksheet_chart_legend_request'
require 'aspose_cells_cloud/requests/put_worksheet_chart_legend_request'
require 'aspose_cells_cloud/requests/delete_worksheet_chart_legend_request'
require 'aspose_cells_cloud/requests/delete_worksheet_charts_request'
require 'aspose_cells_cloud/requests/get_worksheet_chart_title_request'
require 'aspose_cells_cloud/requests/post_worksheet_chart_title_request'
require 'aspose_cells_cloud/requests/put_worksheet_chart_title_request'
require 'aspose_cells_cloud/requests/delete_worksheet_chart_title_request'
require 'aspose_cells_cloud/requests/get_chart_series_axis_request'
require 'aspose_cells_cloud/requests/get_chart_category_axis_request'
require 'aspose_cells_cloud/requests/get_chart_value_axis_request'
require 'aspose_cells_cloud/requests/get_chart_second_category_axis_request'
require 'aspose_cells_cloud/requests/get_chart_second_value_axis_request'
require 'aspose_cells_cloud/requests/post_chart_series_axis_request'
require 'aspose_cells_cloud/requests/post_chart_category_axis_request'
require 'aspose_cells_cloud/requests/post_chart_value_axis_request'
require 'aspose_cells_cloud/requests/post_chart_second_category_axis_request'
require 'aspose_cells_cloud/requests/post_chart_second_value_axis_request'
require 'aspose_cells_cloud/requests/get_worksheet_conditional_formattings_request'
require 'aspose_cells_cloud/requests/get_worksheet_conditional_formatting_request'
require 'aspose_cells_cloud/requests/put_worksheet_conditional_formatting_request'
require 'aspose_cells_cloud/requests/put_worksheet_format_condition_request'
require 'aspose_cells_cloud/requests/put_worksheet_format_condition_area_request'
require 'aspose_cells_cloud/requests/put_worksheet_format_condition_condition_request'
require 'aspose_cells_cloud/requests/delete_worksheet_conditional_formattings_request'
require 'aspose_cells_cloud/requests/delete_worksheet_conditional_formatting_request'
require 'aspose_cells_cloud/requests/delete_worksheet_conditional_formatting_area_request'
require 'aspose_cells_cloud/requests/get_workbook_request'
require 'aspose_cells_cloud/requests/put_convert_workbook_request'
require 'aspose_cells_cloud/requests/post_workbook_save_as_request'
require 'aspose_cells_cloud/requests/post_convert_workbook_to_pdf_request'
require 'aspose_cells_cloud/requests/post_convert_workbook_to_png_request'
require 'aspose_cells_cloud/requests/post_convert_workbook_to_docx_request'
require 'aspose_cells_cloud/requests/post_convert_workbook_to_pptx_request'
require 'aspose_cells_cloud/requests/post_convert_workbook_to_html_request'
require 'aspose_cells_cloud/requests/post_convert_workbook_to_markdown_request'
require 'aspose_cells_cloud/requests/post_convert_workbook_to_json_request'
require 'aspose_cells_cloud/requests/post_convert_workbook_to_sql_request'
require 'aspose_cells_cloud/requests/post_convert_workbook_to_csv_request'
require 'aspose_cells_cloud/requests/post_export_request'
require 'aspose_cells_cloud/requests/post_workbook_export_xml_request'
require 'aspose_cells_cloud/requests/post_workbook_import_json_request'
require 'aspose_cells_cloud/requests/post_workbook_import_xml_request'
require 'aspose_cells_cloud/requests/post_import_data_request'
require 'aspose_cells_cloud/requests/post_workbook_data_cleansing_request'
require 'aspose_cells_cloud/requests/post_data_cleansing_request'
require 'aspose_cells_cloud/requests/post_workbook_data_deduplication_request'
require 'aspose_cells_cloud/requests/post_data_deduplication_request'
require 'aspose_cells_cloud/requests/post_workbook_data_fill_request'
require 'aspose_cells_cloud/requests/post_data_fill_request'
require 'aspose_cells_cloud/requests/post_delete_incomplete_rows_request'
require 'aspose_cells_cloud/requests/post_data_transformation_request'
require 'aspose_cells_cloud/requests/get_worksheet_hyperlinks_request'
require 'aspose_cells_cloud/requests/get_worksheet_hyperlink_request'
require 'aspose_cells_cloud/requests/delete_worksheet_hyperlink_request'
require 'aspose_cells_cloud/requests/post_worksheet_hyperlink_request'
require 'aspose_cells_cloud/requests/put_worksheet_hyperlink_request'
require 'aspose_cells_cloud/requests/delete_worksheet_hyperlinks_request'
require 'aspose_cells_cloud/requests/post_assemble_request'
require 'aspose_cells_cloud/requests/post_compress_request'
require 'aspose_cells_cloud/requests/post_merge_request'
require 'aspose_cells_cloud/requests/post_split_request'
require 'aspose_cells_cloud/requests/post_search_request'
require 'aspose_cells_cloud/requests/post_replace_request'
require 'aspose_cells_cloud/requests/post_import_request'
require 'aspose_cells_cloud/requests/post_watermark_request'
require 'aspose_cells_cloud/requests/post_clear_objects_request'
require 'aspose_cells_cloud/requests/post_reverse_request'
require 'aspose_cells_cloud/requests/post_repair_request'
require 'aspose_cells_cloud/requests/post_rotate_request'
require 'aspose_cells_cloud/requests/post_metadata_request'
require 'aspose_cells_cloud/requests/get_metadata_request'
require 'aspose_cells_cloud/requests/delete_metadata_request'
require 'aspose_cells_cloud/requests/get_worksheet_list_objects_request'
require 'aspose_cells_cloud/requests/get_worksheet_list_object_request'
require 'aspose_cells_cloud/requests/put_worksheet_list_object_request'
require 'aspose_cells_cloud/requests/delete_worksheet_list_objects_request'
require 'aspose_cells_cloud/requests/delete_worksheet_list_object_request'
require 'aspose_cells_cloud/requests/post_worksheet_list_object_request'
require 'aspose_cells_cloud/requests/post_worksheet_list_object_convert_to_range_request'
require 'aspose_cells_cloud/requests/post_worksheet_list_object_summarize_with_pivot_table_request'
require 'aspose_cells_cloud/requests/post_worksheet_list_object_sort_table_request'
require 'aspose_cells_cloud/requests/post_worksheet_list_object_remove_duplicates_request'
require 'aspose_cells_cloud/requests/post_worksheet_list_object_insert_slicer_request'
require 'aspose_cells_cloud/requests/post_worksheet_list_column_request'
require 'aspose_cells_cloud/requests/post_worksheet_list_columns_total_request'
require 'aspose_cells_cloud/requests/get_worksheet_ole_objects_request'
require 'aspose_cells_cloud/requests/get_worksheet_ole_object_request'
require 'aspose_cells_cloud/requests/delete_worksheet_ole_objects_request'
require 'aspose_cells_cloud/requests/delete_worksheet_ole_object_request'
require 'aspose_cells_cloud/requests/post_update_worksheet_ole_object_request'
require 'aspose_cells_cloud/requests/put_worksheet_ole_object_request'
require 'aspose_cells_cloud/requests/get_vertical_page_breaks_request'
require 'aspose_cells_cloud/requests/get_horizontal_page_breaks_request'
require 'aspose_cells_cloud/requests/get_vertical_page_break_request'
require 'aspose_cells_cloud/requests/get_horizontal_page_break_request'
require 'aspose_cells_cloud/requests/put_vertical_page_break_request'
require 'aspose_cells_cloud/requests/put_horizontal_page_break_request'
require 'aspose_cells_cloud/requests/delete_vertical_page_breaks_request'
require 'aspose_cells_cloud/requests/delete_horizontal_page_breaks_request'
require 'aspose_cells_cloud/requests/delete_vertical_page_break_request'
require 'aspose_cells_cloud/requests/delete_horizontal_page_break_request'
require 'aspose_cells_cloud/requests/get_page_setup_request'
require 'aspose_cells_cloud/requests/post_page_setup_request'
require 'aspose_cells_cloud/requests/delete_header_footer_request'
require 'aspose_cells_cloud/requests/get_header_request'
require 'aspose_cells_cloud/requests/post_header_request'
require 'aspose_cells_cloud/requests/get_footer_request'
require 'aspose_cells_cloud/requests/post_footer_request'
require 'aspose_cells_cloud/requests/post_fit_wide_to_pages_request'
require 'aspose_cells_cloud/requests/post_fit_tall_to_pages_request'
require 'aspose_cells_cloud/requests/get_worksheet_pictures_request'
require 'aspose_cells_cloud/requests/get_worksheet_picture_with_format_request'
require 'aspose_cells_cloud/requests/put_worksheet_add_picture_request'
require 'aspose_cells_cloud/requests/post_worksheet_picture_request'
require 'aspose_cells_cloud/requests/delete_worksheet_picture_request'
require 'aspose_cells_cloud/requests/delete_worksheet_pictures_request'
require 'aspose_cells_cloud/requests/get_worksheet_pivot_tables_request'
require 'aspose_cells_cloud/requests/get_worksheet_pivot_table_request'
require 'aspose_cells_cloud/requests/get_pivot_table_field_request'
require 'aspose_cells_cloud/requests/get_worksheet_pivot_table_filters_request'
require 'aspose_cells_cloud/requests/get_worksheet_pivot_table_filter_request'
require 'aspose_cells_cloud/requests/put_worksheet_pivot_table_request'
require 'aspose_cells_cloud/requests/put_pivot_table_field_request'
require 'aspose_cells_cloud/requests/put_worksheet_pivot_table_filter_request'
require 'aspose_cells_cloud/requests/post_pivot_table_field_hide_item_request'
require 'aspose_cells_cloud/requests/post_pivot_table_field_move_to_request'
require 'aspose_cells_cloud/requests/post_pivot_table_cell_style_request'
require 'aspose_cells_cloud/requests/post_pivot_table_style_request'
require 'aspose_cells_cloud/requests/post_pivot_table_update_pivot_fields_request'
require 'aspose_cells_cloud/requests/post_pivot_table_update_pivot_field_request'
require 'aspose_cells_cloud/requests/post_worksheet_pivot_table_calculate_request'
require 'aspose_cells_cloud/requests/post_worksheet_pivot_table_move_request'
require 'aspose_cells_cloud/requests/delete_worksheet_pivot_tables_request'
require 'aspose_cells_cloud/requests/delete_worksheet_pivot_table_request'
require 'aspose_cells_cloud/requests/delete_pivot_table_field_request'
require 'aspose_cells_cloud/requests/delete_worksheet_pivot_table_filters_request'
require 'aspose_cells_cloud/requests/delete_worksheet_pivot_table_filter_request'
require 'aspose_cells_cloud/requests/get_document_properties_request'
require 'aspose_cells_cloud/requests/put_document_property_request'
require 'aspose_cells_cloud/requests/get_document_property_request'
require 'aspose_cells_cloud/requests/delete_document_property_request'
require 'aspose_cells_cloud/requests/delete_document_properties_request'
require 'aspose_cells_cloud/requests/post_digital_signature_request'
require 'aspose_cells_cloud/requests/post_encrypt_workbook_request'
require 'aspose_cells_cloud/requests/delete_decrypt_workbook_request'
require 'aspose_cells_cloud/requests/post_protect_workbook_request'
require 'aspose_cells_cloud/requests/delete_un_protect_workbook_request'
require 'aspose_cells_cloud/requests/put_document_protect_from_changes_request'
require 'aspose_cells_cloud/requests/delete_document_un_protect_from_changes_request'
require 'aspose_cells_cloud/requests/post_unlock_request'
require 'aspose_cells_cloud/requests/post_lock_request'
require 'aspose_cells_cloud/requests/post_protect_request'
require 'aspose_cells_cloud/requests/post_worksheet_cells_ranges_copy_request'
require 'aspose_cells_cloud/requests/post_worksheet_cells_range_merge_request'
require 'aspose_cells_cloud/requests/post_worksheet_cells_range_un_merge_request'
require 'aspose_cells_cloud/requests/post_worksheet_cells_range_style_request'
require 'aspose_cells_cloud/requests/get_worksheet_cells_range_value_request'
require 'aspose_cells_cloud/requests/post_worksheet_cells_range_value_request'
require 'aspose_cells_cloud/requests/post_worksheet_cells_range_move_to_request'
require 'aspose_cells_cloud/requests/post_worksheet_cells_range_sort_request'
require 'aspose_cells_cloud/requests/post_worksheet_cells_range_outline_border_request'
require 'aspose_cells_cloud/requests/post_worksheet_cells_range_column_width_request'
require 'aspose_cells_cloud/requests/post_worksheet_cells_range_row_height_request'
require 'aspose_cells_cloud/requests/put_worksheet_cells_range_request'
require 'aspose_cells_cloud/requests/delete_worksheet_cells_range_request'
require 'aspose_cells_cloud/requests/get_worksheet_shapes_request'
require 'aspose_cells_cloud/requests/get_worksheet_shape_request'
require 'aspose_cells_cloud/requests/put_worksheet_shape_request'
require 'aspose_cells_cloud/requests/delete_worksheet_shapes_request'
require 'aspose_cells_cloud/requests/delete_worksheet_shape_request'
require 'aspose_cells_cloud/requests/post_worksheet_shape_request'
require 'aspose_cells_cloud/requests/post_worksheet_group_shape_request'
require 'aspose_cells_cloud/requests/post_worksheet_ungroup_shape_request'
require 'aspose_cells_cloud/requests/get_worksheet_sparkline_groups_request'
require 'aspose_cells_cloud/requests/get_worksheet_sparkline_group_request'
require 'aspose_cells_cloud/requests/delete_worksheet_sparkline_groups_request'
require 'aspose_cells_cloud/requests/delete_worksheet_sparkline_group_request'
require 'aspose_cells_cloud/requests/put_worksheet_sparkline_group_request'
require 'aspose_cells_cloud/requests/post_worksheet_sparkline_group_request'
require 'aspose_cells_cloud/requests/post_run_task_request'
require 'aspose_cells_cloud/requests/post_add_text_content_request'
require 'aspose_cells_cloud/requests/post_trim_content_request'
require 'aspose_cells_cloud/requests/post_update_word_case_request'
require 'aspose_cells_cloud/requests/post_remove_characters_request'
require 'aspose_cells_cloud/requests/get_workbook_default_style_request'
require 'aspose_cells_cloud/requests/get_workbook_text_items_request'
require 'aspose_cells_cloud/requests/get_workbook_names_request'
require 'aspose_cells_cloud/requests/put_workbook_name_request'
require 'aspose_cells_cloud/requests/get_workbook_name_request'
require 'aspose_cells_cloud/requests/post_workbook_name_request'
require 'aspose_cells_cloud/requests/get_workbook_name_value_request'
require 'aspose_cells_cloud/requests/delete_workbook_names_request'
require 'aspose_cells_cloud/requests/delete_workbook_name_request'
require 'aspose_cells_cloud/requests/post_workbooks_merge_request'
require 'aspose_cells_cloud/requests/post_workbooks_text_search_request'
require 'aspose_cells_cloud/requests/post_workbook_text_replace_request'
require 'aspose_cells_cloud/requests/post_workbook_get_smart_marker_result_request'
require 'aspose_cells_cloud/requests/put_workbook_create_request'
require 'aspose_cells_cloud/requests/post_workbook_split_request'
require 'aspose_cells_cloud/requests/post_workbook_calculate_formula_request'
require 'aspose_cells_cloud/requests/post_autofit_workbook_rows_request'
require 'aspose_cells_cloud/requests/post_autofit_workbook_columns_request'
require 'aspose_cells_cloud/requests/get_workbook_settings_request'
require 'aspose_cells_cloud/requests/post_workbook_settings_request'
require 'aspose_cells_cloud/requests/put_workbook_background_request'
require 'aspose_cells_cloud/requests/delete_workbook_background_request'
require 'aspose_cells_cloud/requests/put_workbook_water_marker_request'
require 'aspose_cells_cloud/requests/get_page_count_request'
require 'aspose_cells_cloud/requests/get_worksheets_request'
require 'aspose_cells_cloud/requests/get_worksheet_with_format_request'
require 'aspose_cells_cloud/requests/put_change_visibility_worksheet_request'
require 'aspose_cells_cloud/requests/put_active_worksheet_request'
require 'aspose_cells_cloud/requests/put_insert_new_worksheet_request'
require 'aspose_cells_cloud/requests/put_add_new_worksheet_request'
require 'aspose_cells_cloud/requests/delete_worksheet_request'
require 'aspose_cells_cloud/requests/delete_worksheets_request'
require 'aspose_cells_cloud/requests/post_move_worksheet_request'
require 'aspose_cells_cloud/requests/put_protect_worksheet_request'
require 'aspose_cells_cloud/requests/delete_unprotect_worksheet_request'
require 'aspose_cells_cloud/requests/get_worksheet_text_items_request'
require 'aspose_cells_cloud/requests/get_worksheet_comments_request'
require 'aspose_cells_cloud/requests/get_worksheet_comment_request'
require 'aspose_cells_cloud/requests/put_worksheet_comment_request'
require 'aspose_cells_cloud/requests/post_worksheet_comment_request'
require 'aspose_cells_cloud/requests/delete_worksheet_comment_request'
require 'aspose_cells_cloud/requests/delete_worksheet_comments_request'
require 'aspose_cells_cloud/requests/get_worksheet_merged_cells_request'
require 'aspose_cells_cloud/requests/get_worksheet_merged_cell_request'
require 'aspose_cells_cloud/requests/get_worksheet_calculate_formula_request'
require 'aspose_cells_cloud/requests/post_worksheet_calculate_formula_request'
require 'aspose_cells_cloud/requests/post_worksheet_text_search_request'
require 'aspose_cells_cloud/requests/post_worksheet_text_replace_request'
require 'aspose_cells_cloud/requests/post_worksheet_range_sort_request'
require 'aspose_cells_cloud/requests/post_autofit_worksheet_row_request'
require 'aspose_cells_cloud/requests/post_autofit_worksheet_rows_request'
require 'aspose_cells_cloud/requests/post_autofit_worksheet_columns_request'
require 'aspose_cells_cloud/requests/put_worksheet_background_request'
require 'aspose_cells_cloud/requests/delete_worksheet_background_request'
require 'aspose_cells_cloud/requests/put_worksheet_freeze_panes_request'
require 'aspose_cells_cloud/requests/delete_worksheet_freeze_panes_request'
require 'aspose_cells_cloud/requests/post_copy_worksheet_request'
require 'aspose_cells_cloud/requests/post_rename_worksheet_request'
require 'aspose_cells_cloud/requests/post_update_worksheet_property_request'
require 'aspose_cells_cloud/requests/get_named_ranges_request'
require 'aspose_cells_cloud/requests/get_named_range_value_request'
require 'aspose_cells_cloud/requests/post_update_worksheet_zoom_request'
require 'aspose_cells_cloud/requests/get_worksheet_page_count_request'
require 'aspose_cells_cloud/requests/get_worksheet_validations_request'
require 'aspose_cells_cloud/requests/get_worksheet_validation_request'
require 'aspose_cells_cloud/requests/put_worksheet_validation_request'
require 'aspose_cells_cloud/requests/post_worksheet_validation_request'
require 'aspose_cells_cloud/requests/delete_worksheet_validation_request'
require 'aspose_cells_cloud/requests/delete_worksheet_validations_request'
require 'aspose_cells_cloud/requests/download_file_request'
require 'aspose_cells_cloud/requests/upload_file_request'
require 'aspose_cells_cloud/requests/copy_file_request'
require 'aspose_cells_cloud/requests/move_file_request'
require 'aspose_cells_cloud/requests/delete_file_request'
require 'aspose_cells_cloud/requests/get_files_list_request'
require 'aspose_cells_cloud/requests/create_folder_request'
require 'aspose_cells_cloud/requests/copy_folder_request'
require 'aspose_cells_cloud/requests/move_folder_request'
require 'aspose_cells_cloud/requests/delete_folder_request'
require 'aspose_cells_cloud/requests/storage_exists_request'
require 'aspose_cells_cloud/requests/object_exists_request'
require 'aspose_cells_cloud/requests/get_disc_usage_request'
require 'aspose_cells_cloud/requests/get_file_versions_request'

# APIs
require 'aspose_cells_cloud/api/cells_api'


module AsposeCellsCloud
  class << self
    # Customize default settings for the SDK using block.
    #   AsposeCellsCloud.configure do |config|
    #     config.username = "xxx"
    #     config.password = "xxx"
    #   end
    # If no block given, return the default Configuration object.
    def configure
      if block_given?
        yield(Configuration.default)
      else
        Configuration.default
      end
    end
  end
end